using System;
using Gtk;
using Glade;

namespace AmicEditor
{ 


	public class SaveFileWindow2 : Dialog
	{
		//[Widget] Gtk.ColorButton CatFontColor;
		[Widget] Gtk.Dialog ChooseFile;
		//[Widget] Gtk.Widget dialogvbox1;
		//[Widget] Gtk.FileChooserWidget dialogvbox1;
		[Widget] Gtk.Button btCancel;
        [Widget] Gtk.Button BtOk;
		[Widget] Gtk.Image ImgSel;
	// NOT USED	[Widget] Gtk.Button BtGeneral;
	// NOT USED [Widget] Gtk.Button BtCustom;
		//[Widget] Gtk.FileChooserWidget ImgSelectorWidget;	
		
		[Widget] Gtk.FileChooserWidget ImgSelectorWidget=new Gtk.FileChooserWidget(Gtk.FileChooserAction.Open);
			
		string orig_img="";  // Ruta completa de la imatge original
	 	bool ImageIsValid;
		
		string pathGeneral="";
		string pathCustom="";
		string filename="";
		
		string linkDefault="";
		string linkCustom="";
		
		public SaveFileWindow2 (string _filename)
		{
			Application.Init();
			Glade.XML gxml = new Glade.XML(null, "SaveFileWindow.glade", "ChooseFile", null);
						
			gxml.Autoconnect(this);
			
			
			
			pathGeneral=Preferences.dir_img;
			pathCustom=Preferences.dir_img_custom;
			filename=_filename;
			
			// Links a les carpetes d'imatges
			linkDefault=Preferences.link_default_image;
			linkCustom=Preferences.link_custom_image;
		
			// Comprovem si la imatge és a la galeria Custom
			if(System.IO.File.Exists(pathCustom+"/"+filename))
				orig_img=pathCustom+"/"+filename; // imatge Original Actualitzada
			else //if(System.IO.File.Exists(pathGeneral+"/"+filename)) // En cas contrari busquem a la galeria general
				orig_img=pathGeneral+"/"+filename; // imatge Original Actualitzada 
			/*else {
			    	orig_img=pathGeneral+"/"; // imatge Original Actualitzada 
				}*/
			
			// Afegim els enllaços...
			//ImgSelectorWidget.AddShortcutFolder(pathGeneral);
			//ImgSelectorWidget.AddShortcutFolder(pathCustom);
			
			
			
			Console.WriteLine("****************************************************************");
			//Console.WriteLine(ImgSelectorWidget);
			Console.WriteLine(ImgSelectorWidget.Uris.Length);
			foreach (string st in ImgSelectorWidget.Uris){
				
				Console.WriteLine(st);
			}
			Console.WriteLine("****************************************************************");

			
			
			
			ImgSelectorWidget.AddShortcutFolder(linkCustom);
			ImgSelectorWidget.AddShortcutFolder(linkDefault);
			//ImgSelectorWidget.AddShortcutFolder("/var/lib/lliurex-amic/Galeria Personal");
			
			
			Console.WriteLine("****************************************************************");
			Console.WriteLine(ImgSelectorWidget.Uris);
			Console.WriteLine(ImgSelectorWidget.Uris.Length);
			foreach (string st in ImgSelectorWidget.Uris){
				
				Console.WriteLine(st);
			}
			Console.WriteLine("****************************************************************");

						
			
			// Afegit el filtre d'imatges
			Gtk.FileFilter filter=new Gtk.FileFilter();
						
			filter.Name="Images";
			filter.AddMimeType("image/png");
			filter.AddMimeType("image/jpeg");
			filter.AddMimeType("image/gif");
			filter.AddPattern("*.bmp");
			filter.AddPattern("*.tif");
			filter.AddPattern("*.tga");
			ImgSelectorWidget.AddFilter(filter);

		//	ImgSelectorWidget.RemoveShortcutFolder("*");
			
			//ImgSelectorWidget.RemoveShortcutFolder("/usr/share/lliurex-amic/resources");
			
			//Console.WriteLine("***********+");
		
			//Console.WriteLine(ImgSelectorWidget.ShortcutFolders.);
			
			/*Console.WriteLine(carpetes.Length);
			for (int i=0;i<carpetes.Length;i++)
				Console.WriteLine(carpetes[i]);
			Console.WriteLine("***********+");
			*/
			
			//foreach(string str in ImgSelectorWidget.ShortcutFolders)
			//	ImgSelectorWidget.RemoveShortcutFolder(str);
				//Console.WriteLine(str);
			
			ImgSelectorWidget.SetFilename(orig_img);
			DrawImage(orig_img);
			ImageIsValid=false; // fem que trie una imatge
			
			btCancel.Clicked += HandleBtCancelClicked;
			BtOk.Clicked += HandleBtOkClicked;
			
			ImgSelectorWidget.SelectionChanged += HandleFilechooserwidget1SelectionChanged;
			
			
		}

		/*void HandleBtCustomClicked (object sender, EventArgs e)
		{
				ImgSelectorWidget.SetFilename(pathCustom);
		}

		void HandleBtGeneralClicked (object sender, EventArgs e)
		{
				ImgSelectorWidget.SetFilename(pathGeneral);
		}
		 */
		

		void DrawImage(string file_to_show){
			Gtk.Image MyImage=new Gtk.Image();
			
			if(System.IO.File.Exists(file_to_show))
			{
			Console.WriteLine("Selector: "+file_to_show);
			
				try{
					//Console.WriteLine("Magic ImageMagic=new Magic();");
					Magic ImageMagic=new Magic();
					if(ImageMagic.isImageFile(file_to_show)){
						MyImage=new Gtk.Image(file_to_show);
						ImageIsValid=true;
						Console.WriteLine("LA IMATGE ES CORRECTA");
					} else {
						ImageIsValid=false;
						Console.WriteLine("LA IMATGE NO ES BONA");
					}
				} catch (Exception ex)
				{
					Console.WriteLine("Lliurex Amic Exception: "+ex);
				}
			}
			else 
			   MyImage=new Gtk.Image("rsrc/image-missing.png");		
			
			/*
				if (System.IO.File.Exists(dir_img+"/"+img_source))
				{
					Console.WriteLine("Trobe "+dir_img+"/"+img_source);					
					MiImage = new Gtk.Image(dir_img+"/"+img_source);
				} else { 
					Console.WriteLine("No trobe "+dir_img+"/"+img_source);
					MiImage = new Gtk.Image("rsrc/image-missing.png");
				}
			*/
			
			try{
				int new_width=150;
				int new_height=150;
				
				MyImage.Pixbuf = MyImage.Pixbuf.ScaleSimple(new_width, new_height, Gdk.InterpType.Bilinear);		
				
				this.ImgSel.Pixbuf=MyImage.Pixbuf;
				
			 }catch (Exception ex){
				Console.WriteLine("Lliurex Amic Exception: "+ex);
			}
		}
		
		void HandleFilechooserwidget1SelectionChanged (object sender, EventArgs e)
		{
			DrawImage(ImgSelectorWidget.Filename);
		}

		void HandleBtOkClicked (object sender, EventArgs e)
		{
			if(ImageIsValid){
				try{
					// Comprovem que la imatge estiga al mateix directori
					//Console.WriteLine(ImgSelectorWidget.Filename.LastIndexOf("/"))!=orig_img.Substring(0,orig_img.LastIndexOf("/")))

					// knownpath conté el path del dibuix si el coneix, a partir d'alguna de les rutes d'imatges conegudes
					// Si està fora, és buit: substitueix el doble if de baix
					string knownPath=GeneralUtils.GetFilenameFrom(ImgSelectorWidget.Filename, Preferences.dir_img_custom, Preferences.dir_img);
										
					
					
					if(knownPath=="")
					  //(ImgSelectorWidget.Filename.Substring(0,ImgSelectorWidget.Filename.LastIndexOf("/"))!=pathGeneral)&&
					  //(ImgSelectorWidget.Filename.Substring(0,ImgSelectorWidget.Filename.LastIndexOf("/"))!=pathCustom))
					{ // Si la imatge no és a la galeria general ni de l'usuari...
						
						// Obtenim les rutes i els noms dels arxius
						int pos_ini_file=ImgSelectorWidget.Filename.LastIndexOf("/");
						int long_total=ImgSelectorWidget.Filename.Length;
						int long_file=long_total-pos_ini_file;
						string orig_filename=ImgSelectorWidget.Filename.Substring(pos_ini_file,long_file);
						//string orig_filename=knownPath;
						
						//string dst_path=orig_img.Substring(0,orig_img.LastIndexOf("/"));
						string dst_path=pathCustom; // Copiarem a la galeria...
						
						// Veiem si ha triat un fitxer de fora que ja està dins la galeria...
						Console.WriteLine(dst_path+orig_filename);
						if (System.IO.File.Exists(dst_path+orig_filename)){
							MessageDialog md = new MessageDialog (ChooseFile, DialogFlags.DestroyWithParent,
					        	                              		MessageType.Warning, ButtonsType.YesNo, 
					            	                          		Mono.Unix.Catalog.GetString("The image is already in the Custom Gallery. Do you want to overwrite it?"));
							ResponseType result = (ResponseType)md.Run();
		
							md.Destroy();
		
							if (result==ResponseType.Yes){
							// Si diu que si, eliminem l'arxiu i el tornem a copiar
								System.IO.File.Delete(dst_path+orig_filename);								
								Console.WriteLine("Copiant "+ImgSelectorWidget.Filename+" a "+dst_path+orig_filename);
 							    System.IO.File.Copy(ImgSelectorWidget.Filename, dst_path+orig_filename);
								
								// I l'actualitzem i tanquem la finestra
	
								//AmicEditor.SelectedSoundFile=dst_path+orig_filename;
								//AmicEditor.SelectedSoundFile=orig_filename.Substring(1, orig_filename.Length-1);
								AmicEditor.SelectedImageFile=dst_path+orig_filename;
			
								Application.Quit();
								ChooseFile.Destroy();
							}
							
						} else { // Si no existeix, preguntem si vol copiar-lo (*1)
							MessageDialog md = new MessageDialog (ChooseFile, DialogFlags.DestroyWithParent,
					        	                              		MessageType.Question, ButtonsType.YesNo, 
					            	                          		Mono.Unix.Catalog.GetString("The image is not included in the your Custom Gallery. Do you want to import it there?"));
							ResponseType result = (ResponseType)md.Run();
		
							md.Destroy();
		
							if (result==ResponseType.Yes){
							// Si vol importar-la, la copiem a la galeria
							
								Console.WriteLine("Copiant "+ImgSelectorWidget.Filename+" a "+dst_path+orig_filename);
								System.IO.File.Copy(ImgSelectorWidget.Filename, dst_path+orig_filename);
								
								// I l'actualitzem i tanquem la finestra
	
								//AmicEditor.SelectedSoundFile=dst_path+orig_filename;
								//AmicEditor.SelectedSoundFile=orig_filename.Substring(1, orig_filename.Length-1);
								AmicEditor.SelectedImageFile=dst_path+orig_filename;
			
								Application.Quit();
								ChooseFile.Destroy();
							}
								
						} // del else (*1)
						
						
					} else {
						// Si és una imatge de la galeria, l'actualitza i tanca la finestra
						//Console.WriteLine("aaaaaaaaaaaaaaaaaaaaaqqqqqqqq"+ImgSelectorWidget.Filename);
						AmicEditor.SelectedImageFile=ImgSelectorWidget.Filename;
			
						Application.Quit();
						ChooseFile.Destroy();
							
					}
				
					
				
				} catch(Exception ex){
					Console.WriteLine("LliureX-Amic Exception: "+ex);
					
				}
			} // Del IF
			else{ // Si l'arxiu no és una imatge...
				MessageDialog md = new MessageDialog (ChooseFile, DialogFlags.DestroyWithParent,
				                                      		MessageType.Warning, ButtonsType.Close, 
				                                      		Mono.Unix.Catalog.GetString("You need to select a valid image file."));
					//ResponseType result = (ResponseType)md.Run();
				md.Run();
				md.Destroy();
			}
		}
		void HandleBtCancelClicked (object sender, EventArgs e)
		{	
			Application.Quit();
			ChooseFile.Destroy();
		}

		
		public new void Show(){
			ChooseFile.ShowAll();
			Application.Run();
			
		}
		
				
	}
		
}
